/*!
 * Copyright (c) 2012 - 2021, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  var define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"c39c5b9356": function _(e,o,s,a,b){a();const f=e("a3b83fffb1");e("@bokehjs/base").register_models({MeasureTool:f.MeasureTool})},
"a3b83fffb1": function _(e,t,s,a,i){a();const n=e("tslib"),_=e("@bokehjs/models/tools/edit/edit_tool"),o=e("@bokehjs/models/annotations/label"),l=n.__importStar(e("@bokehjs/core/properties")),r=e("@bokehjs/core/util/object"),d=e("@bokehjs/styles/icons.css"),h=e("@bokehjs/models/annotations/annotation"),c=n.__importStar(e("@bokehjs/core/property_mixins"));class m extends h.AnnotationView{connect_signals(){super.connect_signals(),this.connect(this.model.change,(()=>this.plot_view.request_paint(this)))}_render(){if(!this.model.visible)return;const{ctx:e}=this.layer;e.save(),e.beginPath(),this.visuals.line.set_value(e),e.moveTo(this.model.x_start,this.model.y_start),e.lineTo(this.model.x_end,this.model.y_end),e.stroke(),e.restore()}}s.LineMeasureView=m,m.__name__="LineMeasureView";class u extends h.Annotation{constructor(e){super(e)}static init_LineMeasure(){this.prototype.default_view=m,this.mixins(c.Line),this.define({x_start:[l.Number],x_end:[l.Number],y_start:[l.Number],y_end:[l.Number]})}}s.LineMeasure=u,u.__name__="LineMeasure",u.init_LineMeasure();class b extends _.EditToolView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.active.change,(()=>this._active_change()))}_active_change(){this.model.active||this._reset_measure_band()}_reset_measure_band(){this.model.measure_band.scale.x_start=0,this.model.measure_band.scale.y_start=0,this.model.measure_band.scale.x_end=0,this.model.measure_band.scale.y_end=0,this.model.measure_band.label.text="",this.model.measure_band.pos_label.text=""}_move(e){const{sx:t,sy:s}=e,{frame:a}=this.plot_view,i=a.x_scale.invert(t),n=a.y_scale.invert(s);this.model.measure_band.pos_label.text="x="+Number(i).toFixed(3)+" "+this.model.measure_unit+", y="+Number(n).toFixed(3)+" "+this.model.measure_unit}_move_exit(e){this.model.measure_band.pos_label.text=""}_tap(e){this._reset_measure_band()}_pan_start(e){const{sx:t,sy:s}=e;this.model.measure_band.scale.x_start=t,this.model.measure_band.scale.y_start=s}_pan(e){if(!this.model.active)return;const{sx:t,sy:s}=e,{frame:a}=this.plot_view;this.model.measure_band.scale.x_end=t,this.model.measure_band.scale.y_end=s;const i=a.x_scale.invert(t),n=a.y_scale.invert(s),_=i-a.x_scale.invert(this.model.measure_band.scale.x_start),o=n-a.y_scale.invert(this.model.measure_band.scale.y_start),l=Math.sqrt(_*_+o*o),r=Math.atan2(o,_),d=180*r/Math.PI;this.model.measure_band.label.text="distance="+Number(l).toFixed(3)+" "+this.model.measure_unit+", angle= "+Number(d).toFixed(2)+"° ("+Number(r).toFixed(2)+" rad)"}}s.MeasureToolView=b,b.__name__="MeasureToolView";class x extends _.EditTool{constructor(e){super(e),this.tool_name="Measure",this.icon=d.tool_icon_range,this.event_type=["tap","pan","move","scroll"]}static init_MeasureTool(){this.prototype.default_view=b,this.define({measure_unit:[l.String,""],line_dash:[l.Array,[4,4]],line_color:[l.Color,"black"],line_width:[l.Number,1.5],line_alpha:[l.Number,1]}),this.register_alias("measure",(()=>new x))}get synthetic_renderers(){return r.values(this.measure_band)}initialize(){super.initialize(),this.measure_band={scale:new u({x_start:0,y_start:0,x_end:0,y_end:0,line_dash:this.line_dash,line_color:this.line_color,line_width:this.line_width,line_alpha:this.line_alpha}),label:new o.Label({x:10,y:35,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"}),pos_label:new o.Label({x:10,y:10,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"})}}}s.MeasureTool=x,x.__name__="MeasureTool",x.init_MeasureTool()},
}, "c39c5b9356", {"index":"c39c5b9356","measuretool":"a3b83fffb1"}, {});});
